###############################################################################
#  AC Logger - (by Igor Damiani - VivendoByte) http://www.vivendobyte.net     #
#  Version : 0.7                                     Updated : 12/03/2013     #
###############################################################################

import ac
import acsys
import time
import datetime
import math
import os

block1 = ""
block2 = ""
block3 = ""
header = "counter;time;km/h;gas;brake;gear;clutch;RPM;Lap;FLW Temp;FRW Temp;RLW Temp;RRW Temp;FLW Pres;FRW Pres;RLW Pres;RRW Pres\n"
logger_started = 0
x_start = 10
y_start = 20
x_space = 0
y_space = 30
counter = 0
row_inside_log = 0

##### CUSTOMIZE #################################################
frequency_log = 20
number_precision = 3
save_folder = "C:\\AC Logger\\"
#################################################################

def acMain(ac_version):
	global loggerStartButton, rowLogged, counter, save_folder
	
	if not os.path.exists(save_folder):
		os.makedirs(save_folder)
	
	appWindow = ac.newApp("AC Logger")
	ac.setTitle(appWindow, "")
	ac.setIconPosition(appWindow, -15, -15)
	ac.setSize(appWindow, 150, 80)

	loggerStartButton = ac.addButton(appWindow, "002")
	ac.setPosition(loggerStartButton, x_start, y_start)
	ac.setSize(loggerStartButton, 80, 26)
	ac.setFontAlignment(loggerStartButton, "left")
	ac.setFontSize(loggerStartButton, 15)
	ac.setText(loggerStartButton, "Start")
	ac.addOnClickedListener(loggerStartButton, loggerStartButton_Click)
	
	rowLogged = ac.addLabel(appWindow, "001")
	ac.setPosition(rowLogged, x_start, y_start + y_space)
	ac.setFontSize(rowLogged, 15)
	ac.setText(rowLogged, "0 rows logged")

	ac.addRenderCallback(appWindow, onFormRender)

	ac.log("ac logger loaded")
	return "ac logger"
 
def onFormRender(deltaT):
	global logger_started, out_file, counter, row_inside_log, number_precision, frequency_log, block1, block2, block3

	if logger_started == 1:
		ac.setText(loggerStartButton, "STARTED")
		
	if logger_started == 0:
		ac.setText(loggerStartButton, "STOPPED")
	
	if logger_started == 1:
		counter = counter + 1
		
		if counter % frequency_log == 0:
			row_inside_log = row_inside_log + 1
			ac.setText(rowLogged, str(row_inside_log) + " rows logged")
			kmh = str(round(ac.getCarState(0, acsys.CS.SpeedKMH), number_precision)).replace('.', ',')
			moment = datetime.datetime.now().strftime("%H:%M:%S.%f")
			gas = str(round(ac.getCarState(0, acsys.CS.Gas), number_precision)).replace('.', ',')
			brake = str(round(ac.getCarState(0, acsys.CS.Brake), number_precision)).replace('.', ',')
			clutch = str(round(ac.getCarState(0, acsys.CS.Clutch), number_precision)).replace('.', ',')
			gear = str(round(ac.getCarState(0, acsys.CS.Gear), number_precision))
			rpm = str(round(ac.getCarState(0, acsys.CS.RPM), number_precision)).replace('.', ',')
			lapCount = str(round(ac.getCarState(0, acsys.CS.LapCount), number_precision))
			flt, frt, rlt, rrt = ac.getCarState(0, acsys.CS.CurrentTyresCoreTemp)
			flp, frp, rlp, rrp = ac.getCarState(0, acsys.CS.DynamicPressure)
			
			block1 = str(row_inside_log) + ";" + moment + ";" + kmh + ";" + gas + ";" + brake + ";" + clutch + ";" + gear + ";" + rpm + ";" + lapCount + ";"
			block2 = str(round(flt, number_precision)) + ";" + str(round(frt, number_precision)) + ";" + str(round(rlt, number_precision)) + ";" + str(round(rrt, number_precision)) + ";"
			block3 = str(round(flp, number_precision)) + ";" + str(round(frp, number_precision)) + ";" + str(round(rlp, number_precision)) + ";" + str(round(rrp, number_precision))
			
			out_file.write(block1 + block2 + block3 + "\n")

def loggerStartButton_Click(a, b):
	global logger_started, out_file, counter, save_folder, header
	
	if logger_started == 0:
		today = datetime.datetime.now().strftime("%Y%m%d_%H%M%S")
		driver_name = ac.getDriverName(0)
		filename = save_folder + "log_" + driver_name + "_" + ac.getTrackName(0) + "_" + ac.getCarName(0) + "_" + today + ".csv"
		out_file = open(filename,"w")
		out_file.write(header)
		logger_started = 1
	else:
		logger_started = 0
		out_file.flush()
		out_file.close()
		counter = 0
